# The SyncReaderWriter class

(PECL sync >= 1.0.0)

## Introduction

A cross-platform, native implementation of named and unnamed reader-writer objects.

A reader-writer object allows many readers or one writer to access a resource. This is an efficient solution for managing resources where access will primarily be read-only but exclusive write access is occasionally necessary.

## Class synopsis

SyncReaderWriter {
/* Methods */
public __construct ([ string `$name` [, bool `$autounlock` = `TRUE` ]] )
public readlock ([ int `$wait` = -1 ] ) : bool
public readunlock ( void ) : bool
public writelock ([ int `$wait` = -1 ] ) : bool
public writeunlock ( void ) : bool
}

## Table of Contents

- SyncReaderWriter::__construct — Constructs a new SyncReaderWriter object
- SyncReaderWriter::readlock — Waits for a read lock
- SyncReaderWriter::readunlock — Releases a read lock
- SyncReaderWriter::writelock — Waits for an exclusive write lock
- SyncReaderWriter::writeunlock — Releases a write lock